Subject: Re: [PATCH net-next] macvtap/macvlan: use IFF_NO_QUEUE

From: Jason Wang <[email-masked]>
Date: Tue, 25 Aug 2015 19:30:09 +0800

On 08/25/2015 06:17 PM, Michael S. Tsirkin wrote:
> On Mon, Aug 24, 2015 at 04:33:12PM +0800, Jason Wang wrote:
>> > For macvlan, switch to use IFF_NO_QUEUE instead of tx_queue_len = 0.
>> > 
>> > For macvtap, after commit 6acf54f1cf0a6747bac9fea26f34cfc5a9029523
>> > ("macvtap: Add support of packet capture on macvtap
>> > device."). Multiqueue macvtap suffers from single qdisc lock
>> > contention. This is because macvtap claims a non zero tx_queue_len and
>> > it reuses this value as it socket receive queue size.Thanks to
>> > IFF_NO_QUEUE, we can remove the lock contention without breaking
>> > existing socket receive queue length logic.
>> > 
>> > Cc: Patrick McHardy <[email-masked]>
>> > Cc: Vladislav Yasevich <[email-masked]>
>> > Cc: Michael S. Tsirkin <[email-masked]>
>> > Signed-off-by: Jason Wang <[email-masked]>
> Seems to make sense. Give me a day or two to get over the jet lag
> (and get out from under the pile of mail accumulated while I was traveling),
> I'll review properly and ack.
>

A note on this patch: only default qdisc were removed but we don't lose
the ability to attach a qdisc to macvtap (though it may cause lock
contention on multiqueue case).